diff --git a/tar/write.c b/tar/write.c
index 2d076f488..da5a12825 100644
--- a/tar/write.c
+++ b/tar/write.c
@@ -886,6 +886,8 @@ write_hierarchy(struct bsdtar *bsdtar, struct archive *a, const char *path)
 			    "%s", archive_error_string(disk));
 			if (r == ARCHIVE_FATAL || r == ARCHIVE_FAILED) {
 				bsdtar->return_value = 1;
+				archive_entry_free(entry);
+				archive_read_close(disk);
 				return;
 			} else if (r < ARCHIVE_WARN)
 				continue;
